*****************************************************************************
*	8051 C COMPILER FLOATING POINT INTERFACE ROUTINES.                  *
*****************************************************************************

		.linklist
		.symbols

******************************************************************************

		.MODULE	__add_float

;	ADD OPERAND #2 FLOAT POINTED TO BY (R3,R1) TO OPERAND #1 FLOAT POINTED
;	TO BY (R2,R0), AND STORE THE RESULT IN '__oper1_temp_store'.  RETURN
;	WITH R2,R0 POINTING TO THE RESULT.
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_program:	.section

		.global	__add_float
		.extern	__oper1_float_to_double
		.extern	__oper2_float_to_double
		.extern	__oper1_double_to_float
		.extern	__add_double

reg1:		.reg	1
reg3:		.reg	3
reg4:		.reg	4
reg5:		.reg	5

__add_float:	push	reg5		;save msb frame pointer
		push	reg4		;save lsb frame pointer
		push	reg3		;save msb operand 2
		push	reg1		;save lsb operand 2
		lcall	__oper1_float_to_double	;convert operand #1 to a double
		lcall	__oper2_float_to_double	;convert operand #2 to a double
		lcall	__add_double
		lcall	__oper1_double_to_float	;convert result to a float
		pop	reg1		;restore lsb operand 2
		pop	reg3		;restore msb operand 2
		pop	reg4		;restore lsb frame pointer
		pop	reg5		;restore msb frame pointer
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__add_double

;	ADD OPERAND #2 DOUBLE POINTED TO BY (R3,R1) TO OPERAND #1 DOUBLE
;	POINTED TO BY (R2,R0), STORE THE RESULT IN '__oper1_conversion_store'.
;	RETURN WITH R2,R0 POINTING TO THE RESULT.
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_uninit_data: .section

		.extern	__oper1_temp_store

lib_program:	.section

		.global	__add_double
		.extern	___add_double
		.extern	__store_double

__add_double:	lcall	___add_double		;perform the addition
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__mult_float

;	MULTIPLY OPERAND #1 FLOAT POINTED TO BY (R2,R0) BY OPERAND #2 FLOAT
;	POINTED TO BY REGISTER (R3,R1), AND STORE THE RESULT IN 
;	'__oper1_conversion_store'.  RETURN WITH R2,R0 POINTING TO THE RESULT.
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_program:	.section

		.global	__mult_float
		.extern	__oper1_float_to_double
		.extern	__oper2_float_to_double
		.extern	__oper1_double_to_float
		.extern	__mult_double

reg1:		.reg	1
reg3:		.reg	3
reg4:		.reg	4
reg5:		.reg	5

__mult_float:	push	reg5		;save msb frame pointer
		push	reg4		;save lsb frame pointer
		push	reg3		;save msb operand 2
		push	reg1		;save lsb operand 2
		lcall	__oper1_float_to_double	;convert operand #1 to a double
		lcall	__oper2_float_to_double	;convert operand #2 to a double
		lcall	__mult_double
		lcall	__oper1_double_to_float	;convert result to a float
		pop	reg1		;restore lsb operand 2
		pop	reg3		;restore msb operand 2
		pop	reg4		;restore lsb frame pointer
		pop	reg5		;restore msb frame pointer
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__mult_double

;	MULTIPLY OPERAND #1 DOUBLE POINTED TO BY (R2,R0) BY OPERAND #2 DOUBLE
;	POINTED TO BY (R3,R1), AND STORE THE RESULT IN '__oper1_temp_store'.
;	RETURN WITH R2,R0 POINTING TO THE RESULT.
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_uninit_data: .section

		.extern	__oper1_temp_store

lib_program:	.section

		.global	__mult_double
		.extern	___mult_double
		.extern	__store_double

__mult_double:	lcall	___mult_double		;perform the multiplication
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__div_float

;	DIVIDE OPERAND #1 FLOAT POINTED TO BY (R2,R0) BY OPERAND #2 FLOAT
;	POINTED TO BY (R3,R1), STORE THE RESULT IN '__oper1_conversion_store'.
;	RETURN WITH R2,R0 POINTING TO THE RESULT.
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_program:	.section

		.global	__div_float
		.extern	__oper1_float_to_double
		.extern	__oper2_float_to_double
		.extern	__oper1_double_to_float
		.extern	__div_double

reg1:		.reg	1
reg3:		.reg	3
reg4:		.reg	4
reg5:		.reg	5

__div_float:	push	reg5		;save msb frame pointer
		push	reg4		;save lsb frame pointer
		push	reg3		;save msb operand 2
		push	reg1		;save lsb operand 2
		lcall	__oper1_float_to_double	;convert operand #1 to a double
		lcall	__oper2_float_to_double	;convert operand #2 to a double
		lcall	__div_double
		lcall	__oper1_double_to_float	;convert result to a float
		pop	reg1		;restore lsb operand 2
		pop	reg3		;restore msb operand 2
		pop	reg4		;restore lsb frame pointer
		pop	reg5		;restore msb frame pointer
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__div_double

;	DIVIDE OPERAND #1 DOUBLE POINTED TO BY (R2,R0) BY OPERAND #2 DOUBLE
;	POINTED TO BY (R3,R1), AND STORE THE RESULT IN '__oper1_temp_store'.
;	RETURN WITH R2,R0 POINTING TO THE RESULT.
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_uninit_data: .section

		.extern	__oper1_temp_store

lib_program:	.section

		.global	__div_double
		.extern	___div_double
		.extern	__store_double

__div_double:	lcall	___div_double		;perform the division
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__cmp_float_interface

;	THIS ROUTINE COMPARES OPERAND #1 FLOAT POINTED TO BY (R2,R0) TO
;	OPERAND #2 FLOAT POINTED TO BY (R3,R1).  THE ROUTINE RETURNS TO
;	THE CALLER WITH THE FOLLOWING CODES IN REGISTER R2:
;
;		0 - EQUAL
;		1 - OPERAND #1 (R2,R0) IS LESS THAN OPERAND #2
;		2 - OPERAND #1 (R3,R1) IS GREATER THAN OPERAND #2
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_uninit_data: .section

		.extern	__oper1_conversion_store
		.extern	__oper2_conversion_store
lib_program:	.section

		.global	__cmp_float_interface
		.extern	__oper1_float_to_double
		.extern	__oper2_float_to_double
		.extern	___cmp_double

reg1:		.reg	1
reg3:		.reg	3
reg4:		.reg	4
reg5:		.reg	5

__cmp_float_interface:	.equal	$	
		lcall	__oper1_float_to_double
		lcall	__oper2_float_to_double
		lcall	___cmp_double
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__cmp_double_interface

;	THIS ROUTINE COMPARES OPERAND #1 DOUBLE POINTED TO BY (R2,R0) TO
;	OPERAND #2 DOUBLE POINTED TO BY (R3,R1).  THE ROUTINE RETURNS TO
;	THE CALLER WITH THE FOLLOWING CODES IN REGISTER R2:
;
;		0 - EQUAL
;		1 - OPERAND #1 (R2,R0) IS LESS THAN OPERAND #2
;		2 - OPERAND #1 (R3,R1) IS GREATER THAN OPERAND #2
;
;	THIS ROUTINE MUST NOT MODIFY REGISTER R5,R4 OR REGISTER R3,R1.

lib_program:	.section

		.global	__cmp_double_interface
		.extern	___cmp_double

__cmp_double_interface:  .equal  $
	 	lcall	___cmp_double		;perform the comparison
		ret				;return with result code in D0

		.ENDMOD

******************************************************************************

		.MODULE	__long_to_double_interface

;	CONVERT THE LONG IN R2,R0 TO A DOUBLE.  RETURN WITH THE DOUBLE
;	POINTED TO BY R3,R1.

lib_program:	.section

		.global	__long_to_double_interface
		.extern	___long_to_double

__long_to_double_interface:  .equal  $
		lcall	___long_to_double	;perform the conversion
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__double_to_long_interface

;	CONVERT THE DOUBLE IN R2,R0 TO A LONG.  RETURN WITH THE LONG STORED
;	IN R3,R1.

lib_program:	.section

		.global	__double_to_long_interface
		.extern	___double_to_long

__double_to_long_interface:  .equal  $
		lcall	___double_to_long	;perform the conversion
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__float_to_double_interface

;	CONVERT THE FLOAT POINTED TO BY (R2,R0) TO A DOUBLE.  RETURN WITH
;	THE DOUBLE STORED IN THE LOCATION POINTED TO BY (R3,R1).

lib_program:	.section

		.global	__float_to_double_interface
		.extern	___float_to_double

__float_to_double_interface:  .equal  $
		lcall	___float_to_double	;perform the conversion
		ret

		.ENDMOD

******************************************************************************

		.MODULE	__double_to_float_interface

;	CONVERT THE DOUBLE POINTED TO BY (R2,R0) TO A FLOAT.  RETURN WITH
;	THE FLOAT STORED IN THE LOCATION POINTED TO BY (R3,R1).

lib_program:	.section

		.global	__double_to_float_interface
		.extern	___double_to_float

__double_to_float_interface:  .equal  $
		lcall	___double_to_float	;perform the conversion
		ret

		.ENDMOD

******************************************************************************


		.end

