/*
	test routine for co-ordinate system transformations
	The basic principle is to keep two co-ordinate systems
	A user system set by SC x0,y0,x1,y1 (Ux0,Uy0,Ux1,Uy1)
	And a machine system (Sx0,Sy0,Sx1,Sy1)
	To ensure that there is never accumulated roundoff error
	absolute positions in U are translated to absolute positions in S

	x' = (x - Ux0) * (Sx1-Sx0)/(Ux1-Ux0) + Sx0
	y' = (y - Yy0) * (Sy1-Sy0)/(Uy1-Uy0) + Sy0

	For the HPGL emulation translate the input numbers in 1/1000th of an inch
	into 1/10 mm for PA SC and IW

	1 inch = 254 1/100th mm
	1000 1/1000" = 254 1/10th mm so input numbers scaled by 2540/1000
*/
/*
initial page is Ux0,Uy0,Ux1,Uy1 = 0,0,16000,11000
					 Sx0,Sy0,Sx1,Sy1 = 0,0,40640,27940
*/

long Ux0 = 0;
long Uy0 = 0;
long Ux1 = 16000;
long Uy1 = 11000;
long Sx0 = 0;
long Sy0 = 0;
long Sx1 = 40640;
long Sy1 = 27940;

main(int argc, char *argv[])
{
	long x,y;
	if(argc > 2)
	{
		x = atol(argv[1]);
		y = atol(argv[2]);
		x = Sx0 + ((x - Ux0) * (Sx1-Sx0))/(Ux1-Ux0);
		y = Sy0 + ((y - Uy0) * (Sy1-Sy0))/(Uy1-Uy0);
		printf("\nXout = %ld, Yout = %ld",x,y);
	}
}

