	.include c80451.def
TESTING  .equ  0
****************************************************************************
*   2500 A.D. 8051 C COMPILER RUN-TIME STARTUP ROUTINE                 *
****************************************************************************

      .linklist
		.symbols
		.options  dsh

;   Define sections that will be used.  Doing it here generates the
;   proper linking order.

program:      .section      ;program section
prog_addr:      .equal   $
lib_program:      .section stacked     ;library program section
lib_program_addr:   .equal   $
program_end:      .section  stacked    ;end of all program sections
program_end_addr:   .equal   $
const_data:      .section   indirect   ;constant data section
const_data_addr:    .equal   $
lib_const_data:      .section   indirect   ;library constant data
lib_const_data_addr:   .equal   $
init_data:      .section   indirect   ;initialized data section

_TX_XOFF:		db		0		; PTW 12/4/93
_RX_XOFF:		db 	0		; PTW 18/3/93

init_data_addr:      .equal   $
lib_init_data:      .section  indirect    ;library init data section
lib_init_data_addr:   .equal   $
init_data_end:      .section  indirect    ;end of all initialized data
init_data_end_addr:   .equal   $
uninit_data:      .section   indirect   ;uninitialized data section
uninit_data_addr:    .equal   $
uninit_data_end:    .section indirect     ;end of all uninitialized data
uninit_data_end_addr:    .equal   $
lib_temp_constants:   .section   offset 0, ref_only
lib_temp_constants_end:   .section   stacked,  ref_only
lib_temp_constants_size: .equal   $
registers:      .section   reg, offset 0, ref_only

		.registers

      .global   __reg0
      .global   __reg1
		.global   __reg2
      .global   __reg3
      .global   __reg4
		.global   __reg5
      .global   __reg6
		.global   __reg7
		.global   __oper1_lsb
		.global   __oper1_msb
		.global   __oper2_lsb
		.global   __oper2_msb
		.global   __fp_lsb
		.global   __fp_msb
		.global   __stack_lsb
		.global   __stack_msb
		.global   __serial_status
		.global   __CV
		.global   __ATX
		.global   __CT
		.global   __ACL
		.global   __X_SIZE
		.global   __Y_SIZE
		.global   __Z_SIZE
		.global   __DELTA
		.global   __DELTB
		.global   __CCNT
                .if TESTING
                .global   __TESTX  ; step counters
                .global   __TESTY
                .global   __TESTZ
                .endif

__reg0:      .ds   1      ;direct address for r0
__reg1:      .ds   1      ;direct address for r1
__reg2:      .ds   1      ;direct address for r2
__reg3:      .ds   1      ;direct address for r3
__reg4:      .ds   1      ;direct address for r4
__reg5:      .ds   1      ;direct address for r5
__reg6:      .ds   1      ;direct address for r6
__reg7:      .ds   1      ;direct address for r7
__oper1_lsb:   .equal   __reg0      ;equivalent direct address for r0
__oper1_msb:   .equal   __reg2      ;equivalent direct address for r2
__oper2_lsb:   .equal   __reg1      ;equivalent direct address for r1
__oper2_msb:   .equal   __reg3      ;equivalent direct address for r3
__fp_lsb:      .equal   __reg4      ;equivalent direct address for r4
__fp_msb:      .equal   __reg5      ;equivalent direct address for r5
__stack_lsb:   .equal   __reg6      ;equivalent direct address for r6
__stack_msb:   .equal   __reg7      ;equivalent direct address for r7

CV       .ds  1       ; 8 current velocity
ATX      .ds  1       ; 9 Acceleration counts = decel counts
ACL      .ds  1       ; 0a acceleration rate
CT       .ds  2       ; 0b,0c Cruise counts
X_SIZE   .ds  2       ; 0d,0e
Y_SIZE   .ds  2       ; 0f,10
Z_SIZE   .ds  2       ; 11,12
DELTA    .ds  2       ; 13,14
DELTB    .ds  2       ; 15,16
CCNT     .ds  2       ; 17,18
         .if TESTING
__TESTX  .ds  2
__TESTY  .ds  2
__TESTZ  .ds  2
         .endif
HOME_X   EQU    0D8H  ; X - home sensor
HOME_Y   EQU    0D9h  ; Y - home sensor
HOME_Z   EQU    0DAh  ; Z - home sensor
HOME_AZ  EQU    0DBh  ; Z - baseline sensor

FLAG_1   EQU    90h ; go/no go         ; p1.0
FLAG_2   EQU    91h ; accel/decaccel
FLAG_3   EQU    92h ; cruise
GO_X     EQU    93h ; X Y Z flag
GO_Y     EQU    94h ; Y X Z flag
GO_Z     EQU    95h ; Z X Y flag


__CV       .equal  CV       ; current velocity
__ATX      .equal  ATX      ; Acceleration counts = decel counts
__CT       .equal  CT       ; Cruise counts
__ACL      .equal  ACL       ; acceleration rate
__X_SIZE   .equal  X_SIZE       ;
__Y_SIZE   .equal  Y_SIZE       ;
__Z_SIZE   .equal  Z_SIZE       ;
__DELTA    .equal  DELTA       ; 21H,22H
__DELTB    .equal  DELTB       ;
__CCNT     .equal  CCNT     ; current count


CR:      .equal   0dh
LF:      .equal   0ah
BS:      .equal   08h
CTRL_C:      .equal   'C'-40h      ;control c
XOFF:        .equal 19H
XON:         .equal 17h

INTERNAL_STACK:   .equal   28H      ;internal stack address (skip r0 - r7)
EXTERNAL_STACK:   .equal   ffbfh      ;external stack address
INIT_DATA_RUN_ADDR: .equal 0000h   ;init data runtime address
INPUT_BUF_SIZE:   .equal  2048        ;size of input buffer
OUTPUT_BUF_SIZE: .equal   256      ;size of output buffer

		.uninit_data
		.global   __ram_tab,__ram_tab1,__MOV_TAB0,__CPY_TAB,input_buf,end_input_buf
input_buf:   .ds   INPUT_BUF_SIZE   ;allocate input buffer
end_input_buf: .equal $
output_buf:   .ds   OUTPUT_BUF_SIZE ;allocate output buffer
end_output_buf .equal $
__ram_tab:      .ds 512             ; ram table for accel
__ram_tab1:     .ds 512             ; secondary table
		.init_data

		.global   __raw_mode
		.global   _ctrl_c_signal

__raw_mode:       .byte   0      ;enable all input character processing
_ctrl_c_signal:   .word   ctrl_c_reset   ;control c interrupt signal routine

output_buf_empty: .byte   1      ;initialize output buffer empty flag
input_buf_ptr:    .word   input_buf   ;initialize input buffer pointer
rxd_buf_ptr:      .word   input_buf   ;initialize receiver buffer pointer
input_buf_count:  .word   0      ;initialize # of characters in buffer
rxd_buf_count:    .word   0      ;initialize # of buffered characters
output_buf_ptr:   .word   output_buf   ;initialize output buffer pointer
txd_buf_ptr:      .word   output_buf   ;initialize xmitter buffer pointer
output_buf_count: .word   0      ;initialize # of characters in buffer

      .page

      .program

      .global   start
      .global   end
      .global   c8051rt_entry

      .extern   _main
      .extern   __indirect_call

      .org   0000h

start:
	ljmp   c8051rt_startup
	.org   000bh
	ljmp  acctst

      .org   0013h   ;int 1
;      ljmp   KEYINT
;   Interrupt service routines should be put here.

;   Serial port interrupt vector

      .org   0023h

	ljmp   serial_interrupt


;   Entry point for routines to use run-time functions

      .org   0030h

c8051rt_entry:   ljmp   c8051rt_functions


;   Control C signal reset routine

ctrl_c_reset:
	mov   ie,#0         ;disable all interrupts
	mov	sp,#INTERNAL_STACK
	mov   dptr,#$reti_1      ;exec 'iret' twice to clear
	push   dpl         ;the internal interrupt priority
	push   dph         ;hardware
	reti
$reti_1:
	mov   dptr,#$reti_2
	push   dpl
	push   dph
	reti
$reti_2:   .equal   $
;	jmp   cntl_c_restart
	.page

;   Normal startup routine
;
c8051rt_startup:  .equal  $
      mov   0c0h,0ffh   ; p4
      mov   0c8h,0ffh   ; p5
      mov   0d8h,0ffh   ; p6
      mov   p3,#11111111b      ;enable p3 special functions
      mov   scon,#5AH      ;setup serial port mode
      mov   tcon,#54H        ;use t1 as a baud rate generator
      mov   tmod,#20H        ; 8 bit auto-reload mode
      mov   ip,#00000010b       ;set timer 0 to high priority
	   anl	pcon,#7fh
      mov   th1,#0e8h  ; 1200 baud 11.059 Mhz XTAL
;     mov   th1,#0fdh  ; 9600 baud
      setb   tr1         ;enable receiver
      clr	ti
;      mov	sbuf,#'>'
;     lcall  autobaud
	MOV   B,#7FH
	MOV   R1,#7FH
	CLR   A
CLR_LP1:
	MOV   @R1,A
	DEC   R1
	DJNZ  B,CLR_LP1



cntl_c_restart:
	mov   psw,#0
	mov   ip,#00000000b       ;set all priorities the same
	mov   p3,#11111111b      ;enable p3 special functions
	mov   sp,#INTERNAL_STACK   ;init internal stack pointer
	mov   r6,#.low.EXTERNAL_STACK   ;init external stack pointer
	mov   r7,#.high.EXTERNAL_STACK
;   move constant & initialized data into ram

      mov   a,#.low.init_data_end_addr
      mov   b,#.high.init_data_end_addr
      mov   dptr,#const_data_addr
      clr   c
      subb   a,dpl         ;get size of init data area
      mov   r0,a
      mov   a,b
      subb   a,dph
      mov   r1,a
      orl   a,r0         ;check for size = 0
      jz   no_init_data      ;skip move if size = 0
      mov   r2,#.low.program_end_addr ;load addr of init data
      mov   r3,#.high.program_end_addr
      mov   r4,#.low.INIT_DATA_RUN_ADDR ;ld runtime address
      mov   r5,#.high.INIT_DATA_RUN_ADDR
init_loop:   mov   dpl,r2         ;load source byte
      mov   dph,r3
      clr   a
      movc   a,@a+dptr
      inc   dptr         ;increment source address
      mov   r2,dpl
      mov   r3,dph
      mov   dpl,r4         ;store destination byte
      mov   dph,r5
      movx   @dptr,a
      inc   dptr         ;increment destination addr
      mov   r4,dpl
      mov   r5,dph
      mov   a,r0         ;decrement init data size
      clr   c
      subb   a,#1
      mov   r0,a
      mov   a,r1
      subb   a,#0
      mov   r1,a
      orl   a,r0         ;check for size = 0
      jnz   init_loop

;   zero uninitialized data area

no_init_data:
      mov   a,#.low.uninit_data_end_addr
      mov   b,#.high.uninit_data_end_addr
      mov   dptr,#uninit_data_addr
      clr   c
      subb   a,dpl         ;get size of uninit data area
      mov   r0,a
      mov   a,b
      subb   a,dph
      mov   r1,a
      orl   a,r0         ;check for size = 0
      jz   no_uninit_data      ;skip initialization if = 0
uninit_loop:
      clr   a         ;zero uninitialized data area
      movx   @dptr,a
      inc   dptr
      mov   a,r0         ;decrement byte counter
      clr   c
      subb   a,#1
      mov   r0,a
      mov   a,r1
      subb   a,#0
      mov   r1,a
      orl   a,r0
      jnz   uninit_loop
no_uninit_data:
      mov   sp,#INTERNAL_STACK   ;init internal stack pointer
      mov   a,#.low.EXTERNAL_STACK   ;init external stack pointer
      clr   c
      subb   a,#.low.lib_temp_constants_size ;allocate temporaries
      mov   r6,a
      mov   a,#.high.EXTERNAL_STACK
      subb   a,#.high.lib_temp_constants_size
      mov   r7,a
      mov   dptr,#__lib_temp_ptr
      movx   @dptr,a         ;store msb of library temp ptr
      inc   dptr
      mov   a,r6
      movx   @dptr,a         ;store lsb of library temp ptr
      mov   ie,#10010000b      ;enable serial port interrupt
      lcall   __flush_input_buffer
      lcall   __inits
      lcall   MOV_TAB
      lcall   _main         ;execute program
;     add code in here to handle die() routine
;     generate checksum etc.
end:  ljmp   start

      .page

      .init_data

      .global   __lib_temp_ptr
      .global   __standard_in
      .global   __standard_out
      .global   __output_table
      .global   __input_table
      .global   __unget_table
      .global   __status_table

__lib_temp_ptr:   .word         ;ptr to library temporaries
__standard_in:   .word   0
__standard_out:   .word   0

__output_table:   .word   serial_out   ;address of serial port output routine
__input_table:   .word   serial_in   ;address of serial port input routine
end_of_input_table: .equ  $

__unget_table:   .blkb   ((end_of_input_table-__input_table)/2)*2,0
__status_table:  .word   __serial_status
		.program

		.page
; fixed 23/4/93 input_buf_count was word not byte !
__serial_status:

	mov  	dptr,#input_buf_count
	movx 	a,@dptr
        mov     r2,a
        inc     dptr
        movx    a,@dptr
        mov     r0,a
	ret


;   Return to the calling program with the character in register a.

serial_in:   lcall   get_character
      ret

_sgetkey:
get_character:   .equal   $

      push   __reg0      ;save r0
      push   __reg1      ;save r1
$empty_loop:
		push   ie      ;save interrupt enable flags
      clr   ea      ;disable interrupts
      mov   dptr,#input_buf_count ;load addr of character count
      movx   a,@dptr      ;load msb of character count
		mov   r0,a
      inc   dptr
      movx   a,@dptr      ;load lsb of character count
      mov   r1,a
      orl   a,r0      ;check for buffer empty
      jnz   $not_empty
      pop   ie      ;restore interrupt enable flags
      ljmp   $empty_loop   ;wait for character if empty
$not_empty:
      mov   a,r1      ;decrement character count
      clr   c
      subb   a,#1
      mov   r1,a
      mov   a,r0
      subb   a,#0
      mov   dptr,#input_buf_count ;load addr of character count
      movx   @dptr,a      	;store msb of new character count
      inc   dptr
      mov   a,r1
      movx   @dptr,a      	;store lsb of new character count
		pop   ie      		;restore interrupt enable flags
      mov   dptr,#input_buf_ptr ;load addr of input buffer ptr
      movx   a,@dptr      	;load msb of input buffer ptr
      mov   r0,a
      inc   dptr
      movx   a,@dptr      	;load lsb of input buffer ptr
      mov   dpl,a      		;xfer lsb of input buffer ptr
      mov   dph,r0      	;xfer msb of input buffer ptr
      movx   a,@dptr      	;load character
      push   a      		;save character
      inc   dptr      		;inc input buffer ptr
      mov   a,dpl      		;xfer lsb of new buffer ptr
      clr   c      		;check for at end of buffer
      subb   a,# < end_input_buf
      mov   r0,a      		;save result for zero detect
      mov   a,dph
      subb   a,# > end_input_buf
      orl   a,r0
      jnz   $1      		;not at end of buffer if not = 0
      mov   dptr,#input_buf   	;init buffer ptr to start of buffer
$1:
      mov   r0,dpl      	;save lsb of new buffer ptr
      mov   a,dph      		;xfer msb of new buffer ptr
      mov   dptr,#input_buf_ptr ;load addr of input buffer ptr
      movx   @dptr,a      	;store msb of new buffer ptr
      inc   dptr
      mov   a,r0      		;xfer lsb of new buffer ptr
      movx   @dptr,a      	;store lsb of new buffer ptr
      pop   a      		;restore character
      pop   __reg1      	;restore r1
      pop   __reg0      	;restore r0
      ret

      .page

;   Store the character in register a in the output buffer.

serial_out:
      push	acc
$0:
		mov	dptr,#_RX_XOFF
      movx	a,@dptr
      jnz	$0

      pop	acc

      cjne   a,#LF,$1
      mov   a,#CR
      lcall   store_character
      mov   a,#LF
$1:
      lcall   store_character
      ret

store_character:  .equal  $
      push   __reg0      	;save r0
      push   __reg1      	;save r1
      push   __reg2      	;save r2
      push   __reg3      	;save r3
      push   a      		;save character to output
$full_loop:
      push   ie      		;save interrupt enable flags
      clr   ea      		;disable interrupts
      mov   dptr,#output_buf_count ;load addr of character count
      movx   a,@dptr      	;load msb of character count
      mov   r0,a      		;save msb of character count
      inc   dptr
      movx   a,@dptr      	;load lsb of character count
      mov   r2,__reg0   	;save msb of character count
      mov   r3,a      		;save lsb of character count
      clr   c      		;check for output buffer full
      subb   a,#.low.OUTPUT_BUF_SIZE
      mov   r1,a      		;save result for zero check
      mov   a,r0
      subb   a,#.high.OUTPUT_BUF_SIZE
      orl   a,r1
      jnz   $not_full
      pop   ie      		;restore interrupt enable flags
      ljmp   $full_loop   	;loop till a char is xmitted if full
$not_full:
		mov   dptr,#output_buf_count ;load addr of character count
      mov   a,r3      		;xfer lsb of character count
      add   a,#1      		;increment character count
      mov   r3,a
      mov   a,r2      		;xfer msb of character count
      addc   a,#0
      movx   @dptr,a      	;store msb of new character count
      inc   dptr
      mov   a,r3      		;xfer lsb of new character count
      movx   @dptr,a      	;store lsb of new character count
      pop   ie      		;restore interrupt enable flags
      mov   dptr,#output_buf_ptr ;load addr of output buffer ptr
      movx   a,@dptr      	;load msb of output buffer ptr
      mov   r0,a
      inc   dptr
      movx   a,@dptr      	;load lsb of output buffer ptr
      mov   dpl,a      		;xfer lsb of output buffer ptr
      mov   dph,r0      	;xfer msb of output buffer ptr
      pop   a      		;return character to output
      push   a      		;save it again
		movx   @dptr,a      	;store character in output buffer
      inc   dptr      		;increment output buffer ptr
      mov   a,dpl      		;xfer lsb of new output buffer ptr
      clr   c      		;check for at end of buffer
      subb   a,# < end_output_buf
      mov   r0,a      		;save lsb for zero detect
      mov   a,dph      		;xfer msb of new output buffer ptr
      subb   a,# > end_output_buf
      orl   a,r0      		;check for at end of buffer
      jnz   $1
      mov   dptr,#output_buf ;init ptr to start of buffer
$1:
      mov   r0,dpl      ;xfer lsb of new buffer ptr
      mov   a,dph      ;xfer msb of new buffer ptr
      mov   dptr,#output_buf_ptr ;load addr of output buffer ptr
      movx   @dptr,a      ;store msb of new output buffer ptr
      inc   dptr
      mov   a,r0
      movx   @dptr,a      ;store lsb of new output buffer ptr
      mov   dptr,#output_buf_empty ;load addr of buffer empty flag
		movx   a,@dptr      ;load flag
      jz   $2      	  ;don't set ti flag if empty flag = 0
      clr   a      	  ;clear empty flag
      movx   @dptr,a      ;store new flag
      setb   ti      	  ;else set ti flag to start transmission
$2:
      pop   a      ;restore character to output
      pop   __reg3      ;restore r3
      pop   __reg2      ;restore r2
      pop   __reg1      ;restore r1
      pop   __reg0      ;restore r0
      ret

      .page
;
; Added 8/9/92 PTW
; XOFF ALWAYS SETS FLAG anything restarts
;
xonxoff:
	mov   	a,sbuf      	;load character
	clr   	ri      		;clear the receiver interrupt bit
	mov	dptr,#_RX_XOFF
	push	acc
	cjne	a,#XOFF,$0
	sjmp	$1
$0:
	clr	a
$1:
	movx	@dptr,a
	pop	acc
	ret
;   Serial port interrupt service routine.

serial_interrupt:     .equal  $
		push   psw      ;save the flags
		push   dph      ;save dptr
		push   dpl
		push   a      		;save a
		push   __reg0      ;save r0
                push   __reg1      ;save r1
                push   __reg2      ;save r2

;   Input a character if the ri bit is set. Process backspace, signal
;   characters, character echoing  and carriage returns if __raw_mode = 0.

		jb   ri,$receiver_full
		ljmp   $xmit_check
$receiver_full:
		mov   dptr,#__raw_mode   	;load addr of _raw_mode flag
		movx   a,@dptr      	;check for raw mode
		jz   $not__raw_mode   	;process characters if _raw_mode = 0

		call	xonxoff		; get character check for XOFF-XANY

		ljmp   $raw_mode   	;skip character processing
$not__raw_mode:

		call	xonxoff

;   Process backspace

		cjne   a,#BS,$not_bs
		mov   dptr,#rxd_buf_count ;ld addr of character per line count
		movx   a,@dptr      	;load msb of character count
		mov   r0,a
		inc   dptr
		movx   a,@dptr      	;load lsb of character count
		mov   r1,a
		orl   a,r0      		;check for buffer empty
		jnz   $not_empty   	;delete last character if not
		ljmp   $xmit_check   ;else just ignore the backspace
$not_empty:
		mov   dptr,#rxd_buf_count ;ld addr of character per line count
		mov   a,r1      		;decrement character count
		clr   c
		subb   a,#1
		mov   r1,a
		mov   a,r0
		subb   a,#0
      movx   @dptr,a      	;store msb of new character count
      inc   dptr
      mov   a,r1
		movx   @dptr,a      	;store lsb of new character count
      mov   dptr,#rxd_buf_ptr 	;ld addr of receiver buffer ptr
      movx   a,@dptr      	;load msb of buffer ptr
      mov   r0,a
      inc   dptr
      movx   a,@dptr      	;load lsb of buffer ptr
      mov   dpl,a      		;xfer lsb of buffer ptr
      mov   dph,r0      	;xfer msb of buffer ptr
      mov   a,dpl      		;xfer lsb of input buffer ptr
      clr   c      		;check for at start of buffer
      subb   a,# < input_buf
      mov   r0,a
      mov   a,dph
      subb   a,# > input_buf
		orl   a,r0
      jnz   $not_at_start
		mov   dptr,#end_input_buf ;ld addr of end of buf
$not_at_start:
      mov   a,dpl      		;decrement buffer pointer
      clr   c
		subb   a,#1
      mov   r0,a      		;save lsb of new buffer pointer
      mov   a,dph
      subb   a,#0
      mov   dph,a
      mov   dptr,#rxd_buf_ptr 	;load addr of receiver buffer ptr
      movx   @dptr,a      	;store msb of new buffer ptr
      inc   dptr
      mov   a,r0      		;xfer lsb of new buffer ptr
      movx   @dptr,a      	;store lsb of new buffer ptr
      mov   dptr,#output_buf_empty ;check for output buffer empty
      movx   a,@dptr
      jz   $bs_loop1   		;wait for ti to go high before sending
      clr   a      		;else clear flag & start transmit
		movx   @dptr,a
      setb   ti
$bs_loop1:
      jnb   ti,$bs_loop1   	;wait for transmitter ready
      mov   sbuf,#BS   		;echo backspace
      clr   ti      		;clear transmitter ready flag
$bs_loop2:
      jnb   ti,$bs_loop2   	;wait for transmitter ready
      mov   sbuf,#' '   	;echo space
      clr   ti      		;clear transmitter ready flag
$bs_loop3:
      jnb   ti,$bs_loop3   	;wait for transmitter ready
      mov   sbuf,#BS   		;echo backspace
      clr   ti      		;clear transmitter ready flag
      ljmp   $xmit_check

;   Process signal characters

$not_bs:
      cjne   a,#CTRL_C,$not_signal
		mov   dptr,#_ctrl_c_signal ;load address of signal routine
      movx   a,@dptr      	;load msb of signal routine address
		mov   r2,a      		;store it
      inc   dptr
      movx   a,@dptr      	;load lsb of signal routine address
      mov   r0,a      ;store it
		lcall   __indirect_call   ;execute the signal handler
      ljmp   $xmit_check

;   Process carriage returns

$not_signal:
      cjne   a,#CR,$not_cr
      mov   a,#LF      		;replace carriage return with line feed

;   Store the character

$raw_mode:    .equal   $
$not_cr:
      mov   r1,a      		;save character
		mov   dptr,#rxd_buf_ptr 	;load addr of receiver buffer ptr
		movx   a,@dptr      	;load msb of input buffer ptr
		mov   r0,a
		inc   dptr
		movx   a,@dptr      	;load lsb of input buffer ptr
		mov   dpl,a      		;xfer buffer ptr to dptr
		mov   dph,r0
		mov   a,r1      		;return character
		movx   @dptr,a      	;store character in input buffer
		push   a      			;save character
		inc   dptr      		;inc input buffer ptr
		mov   a,dpl      		;check for end of buffer
		clr   c
		subb   a,# < end_input_buf
		mov   r0,a      		;save result for zero check
		mov   a,dph
		subb   a,# > end_input_buf
		orl   a,r0      		;check for buffer ptr = end of buffer
		jnz   $3
		mov   dptr,#input_buf   	;load addr of start of buffer
$3:   mov   r0,dpl      	;save lsb of new buffer ptr
		mov   a,dph      		;xfer msb of buffer ptr
		mov   dptr,#rxd_buf_ptr 	;load address of receiver buffer ptr
		movx   @dptr,a      	;store msb of new buffer ptr
		inc   dptr
      mov   a,r0      		;xfer lsb of new buffer ptr
		movx   @dptr,a      	;store lsb of new buffer ptr

;   If processing characters, store up an entire line before telling the
;   routine that actually reads the characters from the buffer that
;   anything is in the buffer.  This is done by keeping a separate
;   character counter.

      mov   dptr,#__raw_mode   ;check for raw mode
      movx   a,@dptr
      jz   $not_raw_mode_1

;   Here to just store the character in raw mode.

      mov   dptr,#input_buf_count ;load addr of character count
      movx   a,@dptr      	;load msb of character count
      mov   r0,a
		inc   dptr
      movx   a,@dptr      	;load lsb of character count
      add   a,#1      		;increment character count
      xch   a,r0      		;save lsb of new count, get msb
		addc   a,#0      		;add carry into high byte of count
      mov   dptr,#input_buf_count ;load addr of character count
      movx   @dptr,a      	;store msb of new character count
      inc   dptr
      mov   a,r0
      movx   @dptr,a      	;store lsb of new character count
      pop   a      		;clear character off stack
      mov   dptr,#rxd_buf_count ;load addr of char per line count
      clr   a
      movx   @dptr,a      	;zero it in case modes are switched
      inc   dptr
      movx   @dptr,a
      ljmp   $xmit_check

;   Here to store the character when not in raw mode.

$not_raw_mode_1:  .equal  $
      mov   dptr,#rxd_buf_count ;load addr of char per line counter
      movx   a,@dptr      	;load msb of character per line counter
      mov   r0,a
		inc   dptr
      movx   a,@dptr      	;load lsb of character per line counter
      add   a,#1      		;increment character per line counter
      mov   r1,a
      mov   a,r0
      addc   a,#0
      mov    dptr,#rxd_buf_count ;load addr of char per line counter
      movx   @dptr,a      	;store msb of new char per line count
      inc   dptr
      mov   a,r1
      movx   @dptr,a      	;store lsb of new char per line count

;   Echo the character

      mov   dptr,#output_buf_empty ;check for output buffer empty
      movx   a,@dptr
		jz   $echo_loop1   	;wait for ti to go high before sending
      clr   a      		;else clear flag & start transmit
      movx   @dptr,a
      setb   ti
$echo_loop1:
      jnb   ti,$echo_loop1   ;wait till transmitter becomes ready
      pop   a      ;return character
      cjne   a,#LF,$not_lf
      mov   sbuf,#CR   ;echo carriage return line feed pair
      clr   ti

;   Since the character was a carriage return (which was converted to
;   a line feed up above) set the input buffer character count equal to
;   the character per line count.

      mov   dptr,#rxd_buf_count ;load addr of char per line count
      movx   a,@dptr      ;load msb of char per line count
      mov   r0,a
      clr   a      ;clear character per line count
      movx   @dptr,a
		inc   dptr
      movx   a,@dptr      ;load lsb of char per line count
      mov   r1,a
      clr   a      ;clear character per line count
		movx   @dptr,a
      mov   dptr,#input_buf_count ;load addr of input buf char cnt
      mov   a,r0
      movx   @dptr,a      ;store msb of input buffer char count
      inc   dptr
      mov   a,r1
      movx   @dptr,a      ;store lsb of input buffer char count

$echo_loop2:
      jnb   ti,$echo_loop2
      mov   a,#LF
$not_lf:
      mov   sbuf,a      ;echo character
      clr   ti      ;clear transmitter interrupt flag

;   Output a character if the ti bit is set and there is a character
;   to output.

$xmit_check:
		jnb   ti,$2
		mov   dptr,#output_buf_count ;load addr of character count
		movx   a,@dptr      ;load msb of character count
		mov   r0,a
      inc   dptr
      movx   a,@dptr      ;load lsb of character count
      mov   r1,a
      orl   a,r0      ;check for buffer empty
      jnz   $5
      mov   dptr,#output_buf_empty ;load addr of buffer empty flag
      mov   a,#1      ;set flag, which allows the routine that
      movx   @dptr,a      ; stores the character to set ti
      clr   ti      ;clear ti for now
      ljmp   $2
$5:
      mov   a,r1      ;decrement character count
      clr   c
      subb   a,#1
		mov   r1,a
      mov   a,r0
		subb   a,#0
      mov   dptr,#output_buf_count ;load addr of character count
      movx   @dptr,a      ;store msb of new character count
		inc   dptr
      mov   a,r1
      movx   @dptr,a      ;store lsb of new character count
      mov   dptr,#txd_buf_ptr ;load addr of output buffer ptr
      movx   a,@dptr      ;load msb of output buffer ptr
      mov   r0,a
      inc   dptr
      movx   a,@dptr      	;load lsb of output buffer ptr
      mov   dpl,a      		;xfer output buffer ptr -> dptr
      mov   dph,r0
      movx   a,@dptr      	;load character to output
      mov   sbuf,a      	;xmit it
      clr   ti      		;clear the transmitter interrupt bit
      inc   dptr      		;inc output buffer ptr
      mov   a,dpl      		;check for end of buffer
		clr   c
      subb   a,# < end_output_buf
		mov   r0,a      		;save result for zero check
      mov   a,dph
      subb   a,# > end_output_buf
		orl   a,r0
		jnz   $4
      mov   dptr,#output_buf 	;load addr of start of buffer
$4:
      mov   r0,dpl      	;xfer lsb of output buffer ptr
      mov   a,dph      		;xfer msb of output buffer ptr
      mov   dptr,#txd_buf_ptr 	;load addr of output buffer ptr
      movx   @dptr,a      	;store msb of new output buffer ptr
      inc   dptr
      mov   a,r0      		;xfer lsb of new output buffer ptr
      movx   @dptr,a      	;store lsb of new output buffer ptr

$2:
      pop   __reg2      	;restore r2
      pop   __reg1      	;restore r1
		pop   __reg0      	;restore r0
		pop   a      		;restore a
		pop   dpl      		;restore dptr
		pop   dph
		pop   psw      		;restore the flags
		reti

      .page

;   Input buffer flush routine.

      .global   __flush_input_buffer

__flush_input_buffer:  .equal  $
      push   ie      ;save interrupt enables
      clr   ea      ;disable interrupts
      push   dpl      ;save registers
      push   dph
      push   a
      mov   dptr,#input_buf_count ;load addr of character count
      clr   a
      movx   @dptr,a      ;zero character count
      inc   dptr
      movx   @dptr,a
      mov   dptr,#rxd_buf_count ;load addr of receiver count
      movx   @dptr,a      ;zero character count
      inc   dptr
      movx   @dptr,a
      mov   dptr,#rxd_buf_ptr ;set buffer pointers to start of buf
      mov   a,# > input_buf
      movx   @dptr,a
      inc   dptr
      mov   a,# < input_buf
      movx   @dptr,a
      mov   dptr,#input_buf_ptr
      mov   a,#> input_buf
      movx   @dptr,a
      inc   dptr
      mov   a,# < input_buf
      movx   @dptr,a
      pop   a      ;restore registers
      pop   dph
      pop   dpl
      pop   ie      ;restore interrupt enables
      ret

      .page

;   This routine handles monitor calls from external routines.  The
;   routine function is in the 'dptr'.  The following functions are
;   implemented, with the corresponding 'dptr' value.

;   0 - Input a character from the serial port.  Return the character
;       in register a.
;   1 - Output a character to the serial port.  The character to output
;       is in register a.

      .init_data

funct_table:   .word   serial_in   ;serial input routine
      .word   serial_out   ;serial output routine

      .program

c8051rt_functions:  .equal  $
      push   a      ;save register a
      mov   a,dpl      ;multiply function # by 2
      add   a,dpl
      mov   dpl,a
      mov   a,dph
      addc   a,dph
      mov   dph,a
      mov   a,dpl      ;get index to table entry
      add   a,#.low.funct_table
      mov   dpl,a
      mov   a,dph
      addc   a,#.high.funct_table
      mov   dph,a
      movx   a,@dptr      ;load msb of routine address
      mov   r2,a
      inc   dptr
      movx   a,@dptr      ;load lsb of routine address
      mov   r0,a
      pop   a      ;restore register a
      lcall   __indirect_call   ;execute routine
      ret

;   Interrupt function entry code.

__interrupt_entry:  .equal  $
      push   psw         ;save flags
      push   a         ;save accumulator
      mov   a,sp         ;xfer internal stack ptr
      add   a,#-3         ;save ptr to return addr lsb
      push   b         ;save rest of regs
      push   dpl
      push   dph
      push   __reg0
      push   __reg1
      push   __reg2
      push   __reg3
      push   __reg4
      push   __reg5
      push   __reg6
      push   __reg7
      mov   r0,a         ;save ptr to return addr lsb
      mov   dptr,#__lib_temp_ptr     ;save temporary pointer
      movx   a,@dptr
      push   a         ;save high byte of temp ptr
      inc   dptr
      movx   a,@dptr         ;save low byte of temp ptr
      push   a
      mov   a,r6         ;xfer lsb of external stk ptr
      clr   c
      subb   a,#.low.lib_temp_constants_size ;allocate temp storage
      mov   r6,a
      movx   @dptr,a
      mov   a,r7
      subb   a,#.high.lib_temp_constants_size
      mov   r7,a
      mov   dptr,#__lib_temp_ptr
      movx   @dptr,a
      mov   a,@r0         ;load low byte of return addr
      push   a         ;put on stack
      inc   r0
      mov   a,@r0         ;load high byte of return addr
      push   a         ;put on stack
      ret            ;execute interrupt handler
      

;   Interrupt function exit code.
;   This routine is jumped to.  The last item on the stack after all
;   the saved state has been restored is the return address of the 
;   interrupted routine.

__interrupt_exit:  .equal  $
      mov   a,r6      ;deallocate library temporaries
      add   a,#.low.lib_temp_constants_size
      mov   r6,a
      mov   a,r7
      addc   a,#.high.lib_temp_constants_size
      mov   r7,a
      mov   dptr,#__lib_temp_ptr
      pop   b      ;restore low byte of temp ptr
      pop   a      ;restore high byte of temp ptr
      movx   @dptr,a      ;store high byte of temp ptr
      inc   dptr
      mov   a,b      ;xfer low byte of temp ptr
      movx   @dptr,a      ;store low byte of temp ptr
      pop   __reg7      ;restore rest of compiler registers
      pop   __reg6
      pop   __reg5
      pop   __reg4
      pop   __reg3
      pop   __reg2
      pop   __reg1
      pop   __reg0
      pop   dph
      pop   dpl
      pop   b
      pop   a
      pop   psw
      dec   sp      ;delete previous return addr off stk
      dec   sp
      reti         ;return to interrupted routine


X_STEP   EQU    (0C8H+7) ;P5.7
X_DIR    EQU    (0C8H+6) ;P5.6
Y_STEP   EQU    (0C8H+5) ;P5.5
Y_DIR    EQU    (0C8H+4) ;P5.4
Z_STEP   EQU    (0C8H+3) ;P5.3
Z_DIR    EQU    (0C8H+2) ;P5.2

         .global __xyz
	      .global __inits
         .global __go
         .global __xpos
         .global __ypos
         .global __zpos
         .global __xneg
         .global __yneg
         .global __zneg
         .global __setx
         .global __sety
         .global __setz
         .global __clrx
         .global __clry
         .global __clrz

__xpos:
       CLR     X_DIR
       ret
__ypos:
       CLR    Y_DIR
       ret
__zpos:
       CLR   Z_DIR
       ret
__xneg:
       SETB     X_DIR
       ret
__yneg:
       SETB    Y_DIR
       ret
__zneg:
       SETB    Z_DIR
       ret
__setx:
       CLR     X_STEP
       ret
__sety:
       CLR    Y_STEP
       ret
__setz:
       CLR    Z_STEP
       ret
__clrx:
       SETB     X_STEP
       ret
__clry:
       SETB    Y_STEP
       ret
__clrz:
       SETB    Z_STEP
       ret

;      start stepping
__go:
       SETB    FLAG_1
       RET
       .include BR_TEST.ASM

__inits:
       CLR     X_STEP
       CLR     Y_STEP
       CLR     Z_STEP
       CLR     X_DIR
       CLR     Y_DIR
       CLR     Z_DIR
       CLR     FLAG_1
       MOV     ACL,#1
       clr     A
       mov     CCNT,A
       mov     CCNT+1,A
       mov     CV,A
       mov     CT,A
       mov     CT+1,A
       CALL    LOAD_F1
       ANL     TMOD,#0f0h
       ORL     TMOD,#1     ; mode 1 16 bit, mode 2 auto reload for testing
       SETB    ET0
       SETB    EA
       SETB    TR0
       RET
; timer 0 interrupt handler
acctst:
       CLR     TR0
       JB     FLAG_1,DO_IT
       MOV    TH0,#0FFH
       MOV    TL0,#0
       JMP    SKIP_IT
DO_IT:
       PUSH    PSW
       PUSH    ACC
       PUSH    B
       PUSH    DPH
       PUSH    DPL
       JNB     FLAG_3,CRUISE
       JNB     FLAG_2,DECEL   ; flag 2 ==0 decel
ACCEL:
       MOV     A,CCNT+1  ; get accel count
       JZ      ENDAC     ; in case of stuff ups
       DEC     A         ; decrement count
       JZ      ENDAC     ; end of it
       MOV     CCNT+1,A  ; update counter
       MOV     A,CV      ; speed it up
       ADD     A,ACL
       JNC     ENDALL    ;
       SJMP    ENDIT     ; max speed no more velocity change
ENDAC:
       CLR     FLAG_2     ; set decel mode
       MOV     CCNT+1,ATX  ; assume deceleration
       MOV     A,CT+1      ; see if there's some cruising to do
       ORL     A,CT
       JZ      ENDIT       ; no so just decel.
       MOV     CCNT,CT     ; cruise counter load
       MOV     CCNT+1,CT+1 ;
       SETB    FLAG_2
       CLR     FLAG_3      ; over-ride de-cel with cruise
       JMP     ENDIT
DECEL:
       MOV     A,CCNT+1  ; get decel count
       JZ      ENDEC     ; stuff ups !
       DEC     A
       JZ      ENDEC
       MOV     CCNT+1,A  ; keep 'em coming
       MOV     A,CV      ; slow it down
       CLR     C
       SUBB    A,ACL
       JNC     ENDALL    ; update velocity
       SJMP    ENDIT     ; minimum, don't update velocity
ENDEC:
       CLR     FLAG_1    ; set stop flag
       SETB    FLAG_2    ; accel mode
       SETB    FLAG_3    ; no cruise
       MOV     CCNT+1,ATX
       JMP    ENDIT
CRUISE:                ; cruise for counts
       CLR  C
       MOV  A,CCNT+1   ; decrement cruise counter
       SUBB A,#1
       MOV  CCNT+1,A
       MOV  B,A
       MOV  A,CCNT
       SUBB A,#0
       MOV  CCNT,A
       ORL  A,B
       JZ   CX1
       SJMP ENDIT
CX1:
       MOV  A,ATX
       MOV  CCNT+1,A
       JNZ  DO_DECEL
       CLR  FLAG_1     ; if decel count = 0 stop
       SETB FLAG_2
       SETB FLAG_3
       SJMP ENDIT
DO_DECEL:
       SETB FLAG_3    ; set cruise flag to exit cruise mode
       CLR  FLAG_2    ; clr accel flag to decelerate
       JMP  ENDIT
ENDALL:
       MOV     CV,A
ENDIT:
       CALL    DO_BRESH
       MOV    A,CV
       CALL    LOAD_F1
       .if TESTING
       JNB   X_STEP,TX1
       INC_2 __TESTX
TX1:
       JNB   Y_STEP,TX2
       INC_2 __TESTY
TX2:
       JNB   Z_STEP,TX3
       INC_2 __TESTZ
TX3:
       .endif
       POP  DPL
       POP  DPH
       POP  B
       POP  ACC
       POP  PSW

       CLR  X_STEP
       CLR  Y_STEP
       CLR  Z_STEP

SKIP_IT:
       SETB TR0
       RETI


LOAD_F:
       MOV   DPTR,#FTAB
       MOV   B,#2
       MUL   AB
       ADD   A,DPL
       MOV   DPL,A
       MOV   A,DPH
       ADDC  A,B
       MOV   DPH,A
       CLR   A
       MOVC  A,@A+DPTR
       MOV   TH0,A
       MOV   A,#1
       MOVC  A,@A+DPTR
       MOV   TL0,A
       RET

LOAD_F1:
       MOV   DPTR,#__ram_tab
       MOV   B,#2
       MUL   AB
       ADD   A,DPL
       MOV   DPL,A
       MOV   A,DPH
       ADDC  A,B
       MOV   DPH,A
       MOVX  A,@DPTR
       MOV   TH0,A
       INC   DPTR
       MOVX  A,@DPTR
       MOV   TL0,A
       RET
;
;  ROUTINE TO COPY DEFAULT STEPPING TABLE FROM EPROM TO RAM
;  THIS TABLE MAY BE ALTERED BAY BASIC TO CHANGE SPEEDS
;

SWAPIT:
       XCH     A,DPH
       XCH     A,R3
       XCH     A,DPH
       XCH     A,DPL
       XCH     A,R1
       XCH     A,DPL
       RET

MOV_TAB:
        CALL    __MOV_TAB0
        CALL    __MOV_TAB1
        RET

__MOV_TAB1:
       MOV     DPTR,#FTAB
       CALL    SWAPIT
       MOV     DPTR,#__ram_tab1
       CALL    SWAPIT
       MOV     R2,#0
       SJMP    MOV_LP
       RET

__MOV_TAB0:
       MOV     DPTR,#FTAB
       CALL    SWAPIT
       MOV     DPTR,#__ram_tab
       CALL    SWAPIT
       MOV     R2,#0
MOV_LP:
       CLR     A
       MOVC    A,@A+DPTR
       INC     DPTR
       CALL    SWAPIT
       MOVX    @DPTR,A
       INC     DPTR
       CALL    SWAPIT

       CLR     A
       MOVC    A,@A+DPTR
       INC     DPTR
       CALL    SWAPIT
       MOVX    @DPTR,A
       INC     DPTR
       CALL    SWAPIT
       DJNZ    R2,MOV_LP
       RET

__CPY_TAB:
       MOV     DPTR,#__ram_tab1
       CALL    SWAPIT
       MOV     DPTR,#__ram_tab
       CALL    SWAPIT
       MOV     R2,#0
CPY_LP:
       CLR     A
       MOVX    A,@DPTR
       INC     DPTR
       CALL    SWAPIT
       MOVX    @DPTR,A
       INC     DPTR
       CALL    SWAPIT

       CLR     A
       MOVX    A,@DPTR
       INC     DPTR
       CALL    SWAPIT
       MOVX    @DPTR,A
       INC     DPTR
       CALL    SWAPIT
       DJNZ    R2,CPY_LP
       RET
FTAB:
       .include FTAB.ASM
       .include HOME.ASM


		.end   start


